Index: squid/src/cache_cf.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cache_cf.c,v
retrieving revision 1.102
retrieving revision 1.102.2.1
diff -u -r1.102 -r1.102.2.1
--- squid/src/cache_cf.c	23 Sep 2007 14:51:42 -0000	1.102
+++ squid/src/cache_cf.c	27 Nov 2007 08:12:24 -0000	1.102.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: cache_cf.c,v 1.102 2007/09/23 14:51:42 squidadm Exp $
+ * $Id: cache_cf.c,v 1.102.2.1 2007/11/27 08:12:24 adri Exp $
  *
  * DEBUG: section 3     Configuration File Parsing
  * AUTHOR: Harvest Derived
@@ -479,6 +479,7 @@
     requirePathnameExists("Error Directory", Config.errorDirectory);
     authenticateConfigure(&Config.authConfig);
     externalAclConfigure();
+    refreshCheckConfigure();
 #if HTTP_VIOLATIONS
     {
 	const refresh_t *R;
@@ -494,6 +495,12 @@
 	    debug(22, 1) ("WARNING: use of 'override-lastmod' in 'refresh_pattern' violates HTTP\n");
 	    break;
 	}
+	for (R = Config.Refresh; R; R = R->next) {
+	    if (R->stale_while_revalidate <= 0)
+		continue;
+	    debug(22, 1) ("WARNING: use of 'stale-while-revalidate' in 'refresh_pattern' violates HTTP\n");
+	    break;
+	}
     }
 #endif
 #if !HTTP_VIOLATIONS
@@ -1610,6 +1617,34 @@
     }
 }
 
+static u_short
+GetService(const char *proto)
+{
+    struct servent *port = NULL;
+    char *token = strtok(NULL, w_space);
+    if (token == NULL) {
+	self_destruct();
+	return -1;		/* NEVER REACHED */
+    }
+    port = getservbyname(token, proto);
+    if (port != NULL) {
+	return ntohs((u_short) port->s_port);
+    }
+    return xatos(token);
+}
+
+static u_short
+GetTcpService(void)
+{
+    return GetService("tcp");
+}
+
+static u_short
+GetUdpService(void)
+{
+    return GetService("udp");
+}
+
 static void
 parse_peer(peer ** head)
 {
@@ -1634,10 +1669,10 @@
 	p->options.no_digest = 1;
 	p->options.no_netdb_exchange = 1;
     }
-    p->http_port = GetShort();
+    p->http_port = GetTcpService();
     if (!p->http_port)
 	self_destruct();
-    p->icp.port = GetShort();
+    p->icp.port = GetUdpService();
     p->connection_auth = -1;	/* auto */
     while ((token = strtok(NULL, w_space))) {
 	if (!strcasecmp(token, "proxy-only")) {
@@ -2146,7 +2181,13 @@
 	    storeAppendPrintf(entry, " ignore-private");
 	if (head->flags.ignore_auth)
 	    storeAppendPrintf(entry, " ignore-auth");
+	if (head->stale_while_revalidate > 0)
+	    storeAppendPrintf(entry, " stale-while-revalidate=%d", head->stale_while_revalidate);
 #endif
+	if (head->max_stale >= 0)
+	    storeAppendPrintf(entry, " max-stale=%d", head->max_stale);
+	if (head->negative_ttl >= 0)
+	    storeAppendPrintf(entry, " negative-ttl=%d", head->negative_ttl);
 	storeAppendPrintf(entry, "\n");
 	head = head->next;
     }
@@ -2169,6 +2210,9 @@
     int ignore_private = 0;
     int ignore_auth = 0;
 #endif
+    int stale_while_revalidate = -1;
+    int max_stale = -1;
+    int negative_ttl = -1;
     int i;
     refresh_t *t;
     regex_t comp;
@@ -2213,10 +2257,18 @@
 	    ignore_reload = 1;
 	    refresh_nocache_hack = 1;
 	    /* tell client_side.c that this is used */
+	} else if (!strncmp(token, "stale-while-revalidate=", 23)) {
+	    stale_while_revalidate = atoi(token + 23);
 	} else
 #endif
+	if (!strncmp(token, "max-stale=", 10)) {
+	    max_stale = atoi(token + 10);
+	} else if (!strncmp(token, "negative-ttl=", 13)) {
+	    negative_ttl = atoi(token + 13);
+	} else {
 	    debug(22, 0) ("redreshAddToList: Unknown option '%s': %s\n",
 		pattern, token);
+	}
     }
     if ((errcode = regcomp(&comp, pattern, flags)) != 0) {
 	char errbuf[256];
@@ -2253,6 +2305,9 @@
     if (ignore_auth)
 	t->flags.ignore_auth = 1;
 #endif
+    t->stale_while_revalidate = stale_while_revalidate;
+    t->max_stale = max_stale;
+    t->negative_ttl = negative_ttl;
     t->next = NULL;
     while (*head)
 	head = &(*head)->next;
Index: squid/src/cf.data.depend
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf.data.depend,v
retrieving revision 1.1
retrieving revision 1.1.4.1
diff -u -r1.1 -r1.1.4.1
--- squid/src/cf.data.depend	5 Sep 2007 21:51:54 -0000	1.1
+++ squid/src/cf.data.depend	27 Nov 2007 08:12:24 -0000	1.1.4.1
@@ -52,3 +52,4 @@
 programline
 extension_method
 errormap
+refreshCheckHelper
Index: squid/src/cf.data.pre
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf.data.pre,v
retrieving revision 1.209
retrieving revision 1.209.2.1
diff -u -r1.209 -r1.209.2.1
--- squid/src/cf.data.pre	23 Sep 2007 14:51:43 -0000	1.209
+++ squid/src/cf.data.pre	27 Nov 2007 08:12:24 -0000	1.209.2.1
@@ -1,6 +1,6 @@
 
 #
-# $Id: cf.data.pre,v 1.209 2007/09/23 14:51:43 squidadm Exp $
+# $Id: cf.data.pre,v 1.209.2.1 2007/11/27 08:12:24 adri Exp $
 #
 # SQUID Web Proxy Cache          http://www.squid-cache.org/
 # ----------------------------------------------------------
@@ -626,10 +626,18 @@
 
 NOCOMMENT_START
 #Recommended minimum configuration:
-acl all src 0.0.0.0/0.0.0.0
+acl all src all
 acl manager proto cache_object
-acl localhost src 127.0.0.1/255.255.255.255
+acl localhost src 127.0.0.1/32
 acl to_localhost dst 127.0.0.0/8
+#
+# Example rule allowing access from your local networks.
+# Adapt to list your (internal) IP networks from where browsing
+# should be allowed
+acl localnet src 10.0.0.0/8	# RFC1918 possible internal network
+acl localnet src 172.16.0.0/12	# RFC1918 possible internal network
+acl localnet src 192.168.0.0/16	# RFC1918 possible internal network
+#
 acl SSL_ports port 443
 acl Safe_ports port 80		# http
 acl Safe_ports port 21		# ftp
@@ -686,11 +694,10 @@
 #
 # INSERT YOUR OWN RULE(S) HERE TO ALLOW ACCESS FROM YOUR CLIENTS
 
-# Example rule allowing access from your local networks. Adapt
-# to list your (internal) IP networks from where browsing should
-# be allowed
-#acl our_networks src 192.168.1.0/24 192.168.2.0/24
-#http_access allow our_networks
+# Example rule allowing access from your local networks.
+# Adapt localnet in the ACL section to list your (internal) IP networks
+# from where browsing should be allowed
+http_access allow localnet
 
 # And finally deny all other access to this proxy
 http_access deny all
@@ -740,8 +747,9 @@
 	See http_access for details
 
 NOCOMMENT_START
-#Allow ICP queries from everyone
-icp_access allow all
+#Allow ICP queries from local networks only
+icp_access allow localnet
+icp_access deny all
 NOCOMMENT_END
 DOC_END
 
@@ -759,8 +767,15 @@
 
 	See http_access for details
 
-#Allow HTCP queries from everyone
-htcp_access allow all
+	NOTE: The default if no htcp_access lines are present is to
+	deny all traffic. This default may cause problems with peers
+	using the htcp or htcp-oldsquid options.
+
+NOCOMMENT_START
+#Allow HTCP queries from local networks only
+htcp_access allow localnet
+htcp_access deny all
+NOCOMMENT_END
 DOC_END
 
 NAME: htcp_clr_access
@@ -1161,7 +1176,7 @@
 
 	acl normal_service_net src 10.0.0.0/255.255.255.0
 	acl good_service_net src 10.0.1.0/255.255.255.0
-	tcp_outgoing_tos 0x00 normal_service_net 0x00
+	tcp_outgoing_tos 0x00 normal_service_net
 	tcp_outgoing_tos 0x20 good_service_net
 
 	TOS/DSCP values really only have local significance - so you should
@@ -1515,8 +1530,12 @@
 		     use 'htcp' to send HTCP, instead of ICP, queries
 		     to the neighbor.  You probably also want to
 		     set the "icp port" to 4827 instead of 3130.
+		     You must also allow this Squid htcp_access and
+		     http_access in the peer Squid configuration.
 
 		     use 'htcp-oldsquid' to send HTCP to old Squid versions
+		     You must also allow this Squid htcp_access and
+		     http_access in the peer Squid configuration.
 
 		     'originserver' causes this parent peer to be contacted as
 		     a origin server. Meant to be used in accelerator setups.
@@ -2064,6 +2083,20 @@
 	numbers closer together.
 DOC_END
 
+NAME: update_headers
+IFDEF: HTTP_VIOLATIONS
+COMMENT: on|off
+TYPE: onoff
+DEFAULT: on
+LOC: Config.onoff.update_headers
+DOC_START
+	By default Squid updates stored HTTP headers when receiving
+	a 304 response. Set this to off if you want to disable this
+	for disk I/O performance reasons. Disabling this VIOLATES the
+	HTTP standard, and could make you liable for problems which it
+	causes.
+DOC_END
+
 COMMENT_START
  LOGFILE OPTIONS
  -----------------------------------------------------------------------------
@@ -2529,6 +2562,30 @@
  -----------------------------------------------------------------------------
 COMMENT_END
 
+NAME: storeurl_rewrite_program
+TYPE: programline
+LOC: Config.Program.store_rewrite.command
+DEFAULT: none
+DOC_START
+
+DOC_END
+
+NAME: storeurl_rewrite_children
+TYPE: int
+DEFAULT: 5
+LOC: Config.Program.store_rewrite.children
+DOC_START
+
+DOC_END
+
+NAME: storeurl_rewrite_concurrency
+TYPE: int
+DEFAULT: 0
+LOC: Config.Program.store_rewrite.concurrency
+DOC_START
+
+DOC_END
+
 NAME: url_rewrite_program redirect_program
 TYPE: programline
 LOC: Config.Program.url_rewrite.command
@@ -2539,7 +2596,13 @@
 
 	For each requested URL rewriter will receive on line with the format
 
-	URL <SP> client_ip "/" fqdn <SP> user <SP> method <SP> urlgroup <NL>
+	URL <SP> client_ip "/" fqdn <SP> user <SP> method <SP> urlgroup
+	 [<SP> kvpairs] <NL>
+
+	In the future, the rewriter interface will be extended with
+	key=value pairs ("kvpairs" shown above).  Rewriter programs
+	should be prepared to receive and possibly ignore additional
+	whitespace-separated tokens on each input line.
 
 	And the rewriter may return a rewritten URL. The other components of
 	the request line does not need to be returned (ignored if they are).
@@ -2550,7 +2613,7 @@
 
 	It can also return a "urlgroup" that can subsequently be matched
 	in cache_peer_access and similar ACL driven rules. An urlgroup is
-	returned by prefixing the returned url with "!urlgroup!"
+	returned by prefixing the returned URL with "!urlgroup!".
 
 	By default, a URL rewriter is not used.
 DOC_END
@@ -2574,6 +2637,12 @@
 	The number of requests each redirector helper can handle in
 	parallel. Defaults to 0 which indicates the redirector
 	is a old-style single threaded redirector.
+
+	When this directive is set to a value >= 1 then the protocol
+	used to communicate with the helper is modified to include
+	a request ID in front of the request/response. The request
+	ID from the request must be echoed back with the response
+	to that request.
 DOC_END
 
 NAME: url_rewrite_host_header redirect_rewrites_host_header
@@ -2599,6 +2668,14 @@
 	are sent.
 DOC_END
 
+NAME: storeurl_access
+TYPE: acl_access
+DEFAULT: none
+LOC: Config.accessList.storeurl_rewrite
+DOC_START
+
+DOC_END
+
 NAME: redirector_bypass
 TYPE: onoff
 LOC: Config.onoff.redirector_bypass
@@ -2692,6 +2769,16 @@
 NOCOMMENT_END
 DOC_END
 
+NAME: max_stale
+COMMENT: time-units
+TYPE: time_t
+LOC: Config.maxStale
+DEFAULT: 1 week
+DOC_START
+	This option puts an upper limit on how stale content Squid
+	will serve from the cache if cache validation fails.
+DOC_END
+
 NAME: refresh_pattern
 TYPE: refreshpattern
 LOC: Config.Refresh
@@ -2722,6 +2809,9 @@
 		 ignore-no-cache
 		 ignore-private
 		 ignore-auth
+		 stale-while-revalidate=NN
+		 max-stale=NN
+		 negative-ttl=NN
 
 		override-expire enforces min age even if the server
 		sent a Expires: header. Doing this VIOLATES the HTTP
@@ -2758,6 +2848,19 @@
 		Enabling this feature could make you liable for problems which
 		it causes.
 
+		stale-while-revalidate=NN makes Squid perform an asyncronous
+		cache validation if the object isn't more stale than NN.
+		Doing this VIOLATES the HTTP standard. Enabling this
+		feature could make you liable for problems which it
+		causes.
+
+		max-stale=NN provided a maximum staleness factor. Squid won't
+		serve objects more stale than this even if it failed to
+		validate the object.
+
+		negative-ttl=NN overrides the global negative_ttl parameter
+		selectively for URLs matching this pattern (in seconds).
+
 	Basically a cached object is:
 
 		FRESH if expires < now, else STALE
@@ -3232,6 +3335,69 @@
 	or response to be rejected.
 DOC_END
 
+NAME: external_refresh_check
+TYPE: refreshCheckHelper
+DEFAULT: none
+LOC: Config.Program.refresh_check
+DOC_START
+	This option defines an external helper for determining whether to
+	refresh a stale response. It will be called when Squid receives a
+	request for a cached response that is stale; the helper can either
+	confirm that the response is stale with a STALE response, or
+	extend the freshness of the response (thereby avoiding a refresh
+	check) with a FRESH response, along with a freshness=nnn keyword.
+
+	  external_refresh_check [options] FORMAT.. /path/to/helper [helper_args]
+
+	If present, helper_args will be passed to the helper on the command
+	line verbatim.
+
+	Options:
+
+	  children=n	Number of processes to spawn to service external
+			refresh checks (default 5).
+	  concurrency=n	Concurrency level per process. Only used with
+			helpers capable of processing more than one query
+			at a time.
+
+	When using the concurrency option, the protocol is changed by introducing
+	a query channel tag infront of the request/response. The query channel
+	tag is a number between 0 and concurrency−1.
+
+	FORMAT specifications:
+
+	  %CACHE_URI	The URI of the cached response
+	  %RES{Header}	HTTP response header value
+	  %AGE		The age of the cached response
+
+	The request sent to the helper consists of the data in the format
+	specification in the order specified.
+
+	The helper receives lines per the above format specification, and
+	returns lines starting with OK or ERR indicating the validity of
+	the request and optionally followed by additional keywords with
+	more details.  URL escaping is used to protect each value in both
+	requests and responses.
+
+	General result syntax:
+
+	  FRESH / STALE keyword=value ...
+
+	Defined keywords:
+
+	  freshness=nnn	The number of seconds to extend the freshness of
+			the response by.
+	  log=string	String to be logged in access.log. Available as
+			%ef in logformat specifications.
+	  res{Header}=value
+			Value to update response headers with. If already
+			present, the supplied value completely replaces
+			the cached value.
+
+	In the event of a helper−related error (e.g., overload), Squid
+	will always default to STALE.
+DOC_END
+
 COMMENT_START
  TIMEOUTS
  -----------------------------------------------------------------------------
@@ -3404,9 +3570,10 @@
 LOC: Config.EmailProgram
 DOC_START
 	Email program used to send mail if the cache dies.
-	The default is "mail". The specified program must complain
+	The default is "mail". The specified program must comply
 	with the standard Unix mail syntax:
-	mail_program recipient < mailfile
+	  mail-program recipient < mailfile
+
 	Optional command line options can be specified.
 DOC_END
 
@@ -3989,8 +4156,7 @@
 DEFAULT: on
 DOC_START
 	This controls whether the server will generate a Cache Digest
-	of its contents.  By default, Cache Digest generation is
-	enabled if Squid is compiled with USE_CACHE_DIGESTS defined.
+	of its contents.
 DOC_END
 
 NAME: digest_bits_per_entry
@@ -4011,7 +4177,7 @@
 LOC: Config.digest.rebuild_period
 DEFAULT: 1 hour
 DOC_START
-	This is the number of seconds between Cache Digest rebuilds.
+	This is the wait time between Cache Digest rebuilds.
 DOC_END
 
 NAME: digest_rewrite_period
@@ -4021,8 +4187,7 @@
 LOC: Config.digest.rewrite_period
 DEFAULT: 1 hour
 DOC_START
-	This is the number of seconds between Cache Digest writes to
-	disk.
+	This is the wait time between Cache Digest writes to disk.
 DOC_END
 
 NAME: digest_swapout_chunk_size
@@ -4155,31 +4320,46 @@
 TYPE: address
 LOC:Config.Addrs.udp_incoming
 DEFAULT: 0.0.0.0
-DOC_NONE
+DOC_START
+	udp_incoming_address	is used for UDP packets received from other
+				caches.
+
+	The default behavior is to not bind to any specific address.
+
+	Only change this if you want to have all UDP queries received on
+	a specific interface/address.
+
+	NOTE: udp_incoming_address is used by the ICP, HTCP, and DNS
+	modules. Altering it will affect all of them in the same manner.
+
+	see also; udp_outgoing_address
+
+	NOTE, udp_incoming_address and udp_outgoing_address can not
+	have the same value since they both use the same port.
+DOC_END
 
 NAME: udp_outgoing_address
 TYPE: address
 LOC: Config.Addrs.udp_outgoing
 DEFAULT: 255.255.255.255
 DOC_START
-	udp_incoming_address	is used for the ICP socket receiving packets
-				from other caches.
-	udp_outgoing_address	is used for ICP packets sent out to other
+	udp_outgoing_address	is used for UDP packets sent out to other
 				caches.
 
 	The default behavior is to not bind to any specific address.
 
-	A udp_incoming_address value of 0.0.0.0 indicates Squid
-	should listen for UDP messages on all available interfaces.
-
-	If udp_outgoing_address is set to 255.255.255.255 (the default)
-	it will use the same socket as udp_incoming_address. Only
-	change this if you want to have ICP queries sent using another
-	address than where this Squid listens for ICP queries from other
+	Instead it will use the same socket as udp_incoming_address.
+	Only change this if you want to have UDP queries sent using another
+	address than where this Squid listens for UDP queries from other
 	caches.
 
+	NOTE: udp_outgoing_address is used by the ICP, HTCP, and DNS
+	modules. Altering it will affect all of them in the same manner.
+
+	see also; udp_incoming_address
+
 	NOTE, udp_incoming_address and udp_outgoing_address can not
-	have the same value since they both use port 3130.
+	have the same value since they both use the same port.
 DOC_END
 
 NAME: icp_hit_stale
@@ -4580,6 +4760,18 @@
 	acts on cacheable requests.
 DOC_END
 
+NAME: ignore_ims_on_miss
+IFDEF: HTTP_VIOLATIONS
+COMMENT: on|off
+TYPE: onoff
+DEFAULT: off
+LOC: Config.onoff.ignore_ims_on_miss
+DOC_START
+	This options makes Squid ignore If-Modified-Since on
+	cache misses. This is useful while the cache is
+	mostly empty to more quickly have the cache populated.
+DOC_END
+
 NAME: always_direct
 TYPE: acl_access
 LOC: Config.accessList.AlwaysDirect
